#include "son.h"

/******************************************
           SUBROUTINE: crypt.i
******************************************/


extern int
check_key(
#if NeedFunctionPrototypes
	Key *key
#endif
);

extern void
get_check_sum(
#if NeedFunctionPrototypes
	char *str,
	char *sum
#endif
);

extern void
convert_to_block(
#if NeedFunctionPrototypes
	char *block,
	char *str,
	int skip8bit
#endif
);

extern void
convert_to_string(
#if NeedFunctionPrototypes
	char *string,
	char *block,
	int skip8bit
#endif
);

extern char *
make_key(
#if NeedFunctionPrototypes
	char *str
#endif
);

extern void
set_key(
#if NeedFunctionPrototypes
	char *key
#endif
);

extern void
encrypt(
#if NeedFunctionPrototypes
	char *block,
	int fake
#endif
);

/******************************************
           SUBROUTINE: crypt2.i
******************************************/


extern int
check_key2(
#if NeedFunctionPrototypes
	Key *key
#endif
);

extern void
string_to_key2(
#if NeedFunctionPrototypes
	char *key,
	char *str
#endif
);

extern void
key_to_string2(
#if NeedFunctionPrototypes
	char *str,
	char *key
#endif
);

extern void
block_to_number2(
#if NeedFunctionPrototypes
	char *num,
	int *block
#endif
);

extern void
number_to_block2(
#if NeedFunctionPrototypes
	int *block,
	char *num
#endif
);

extern void
key_to_block2(
#if NeedFunctionPrototypes
	int *block,
	char *key
#endif
);

extern void
block_to_key2(
#if NeedFunctionPrototypes
	char *key,
	int *block
#endif
);

extern void
value_to_char(
#if NeedFunctionPrototypes
	char *cpnt,
	int value
#endif
);

extern void
encrypt2(
#if NeedFunctionPrototypes
	int *block
#endif
);

extern void
decrypt2(
#if NeedFunctionPrototypes
	int *block
#endif
);

extern void
shift_block(
#if NeedFunctionPrototypes
	int *block,
	int n,
	int beg,
	int len,
	int invert
#endif
);

extern int
get_index(
#if NeedFunctionPrototypes
	int n,
	int beg,
	int len
#endif
);

extern void
cpblock(
#if NeedFunctionPrototypes
	int *to,
	int *from
#endif
);

/******************************************
           SUBROUTINE: date.i
******************************************/


extern void
convert_to_date(
#if NeedFunctionPrototypes
	char *str,
	Date *date
#endif
);

extern int
get_date(
#if NeedFunctionPrototypes
	Date *cnvt_date,
	char *date
#endif
);

extern int
check_date(
#if NeedFunctionPrototypes
	Date *date
#endif
);

extern int
getnumber(
#if NeedFunctionPrototypes
	int *num,
	int *digits,
	char *string
#endif
);

/******************************************
           SUBROUTINE: getnode.i
******************************************/

extern char *
get_node_id(
#if NeedFunctionPrototypes
	void
#endif
);

/******************************************
           SUBROUTINE: rkeyfile.i
******************************************/


extern int
get_key_info(
#if NeedFunctionPrototypes
	Key *key,
	int print_error,
	int read_file
#endif
);

extern int
get_keyfile_name(
#if NeedFunctionPrototypes
	char *filename
#endif
);

extern char *
get_sonnet_dir(
#if NeedFunctionPrototypes
	int print_error
#endif
);

char *
get_license_id(
#if NeedFunctionPrototypes
	void
#endif
);

extern char *
get_license_id_string(
#if NeedFunctionPrototypes
	void
#endif
);

/******************************************
           SUBROUTINE: rmspace.i
******************************************/


extern void
rmspace(
#if NeedFunctionPrototypes
	char *strng
#endif
);

/******************************************
           SUBROUTINE: security.i
******************************************/


extern int
security(
#if NeedFunctionPrototypes
	int prog_id,
	char *rel_num,
	int print_time,
	char *keyfile
#endif
);

extern void
display_expiration_date(
#if NeedFunctionPrototypes
	Prog *prog
#endif
);

extern int get_sub_limit(
#if NeedFunctionPrototypes
	void
#endif
);

extern char *
get_license_id(
#if NeedFunctionPrototypes
	void
#endif
);

/******************************************
           SUBROUTINE: unnode.i
******************************************/


extern void
add_node(
#if NeedFunctionPrototypes
	Prog *prog,
	char *node
#endif
);

extern void
tolowerstr(
#if NeedFunctionPrototypes
	char *string
#endif
);

/******************************************
           SUBROUTINE: usn.i
******************************************/


extern void
add_sn(
#if NeedFunctionPrototypes
	Key *key,
	char *sn
#endif
);


/******************************************
           SUBROUTINE: wkeystr.i
******************************************/


extern void
write_key_string(
#if NeedFunctionPrototypes
	char **string,
	Key *key,
	int making_key
#endif
);
